'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _yylibUi = require('yylib-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;


function noop() {}

var uiMeta = {
    name: 'ijz-toolbar',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-toolbar', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('enableAffix', true, PropTypes.bool, false, '是否启用固定'), field('bigTitle', '', PropTypes.string, false, '大标题'), field('children', [], PropTypes.array, false, '按钮属性配置'), field('viewMode', 'card', PropTypes.string, PropTypes.oneOf(['card', 'table']), '大标题'), field('goBackBtnVisible', false, PropTypes.bool, false, '返回按钮的是否显示'), field('reloadBtnVisible', true, PropTypes.bool, false, '刷新按钮是否显示'), field('onItemButtonClick', noop, PropTypes.func, false, '右侧按钮项回调，(key, item)=>{}')]
};

var IjzToolBar = _yylibUi.YYClass.create({
    uiMeta: uiMeta,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    onItemButtonClick: function onItemButtonClick(uikey, item, self) {
        var onItemButtonClick = this.props.onItemButtonClick;

        if (item && item.type.displayName === "YYButtonSelect") {
            onItemButtonClick(self, item);
            if (item && item.props && item.props.onClick) {
                item.props.onClick(self, item);
            }
        } else {
            onItemButtonClick(uikey, item);
            if (item && item.props && item.props.onClick) {
                item.props.onClick(uikey, item);
            }
        }
    },
    renderButtons: function renderButtons() {
        var _this = this;

        var _props = this.props,
            children = _props.children,
            reloadBtnVisible = _props.reloadBtnVisible;

        var content = [];
        _react2.default.Children.map(children, function (item, index) {
            content.push(_react2.default.cloneElement(item, { onClick: _this.onItemButtonClick.bind(null, item.props.uikey, item) }));
        });
        content.push(_react2.default.createElement(_yylibUi.YYButton, { type: 'ghost', ref: 'ijz_toolbar_reload', visible: reloadBtnVisible,
            onClick: this.onItemButtonClick.bind(null, 'ijz_toolbar_reload', undefined),
            icon: 'reload' }));
        return content;
    },
    render: function render() {
        var _props2 = this.props,
            bigTitle = _props2.bigTitle,
            enableAffix = _props2.enableAffix,
            viewMode = _props2.viewMode,
            goBackBtnVisible = _props2.goBackBtnVisible,
            otherProps = _objectWithoutProperties(_props2, ['bigTitle', 'enableAffix', 'viewMode', 'goBackBtnVisible']);

        return _react2.default.createElement(
            _yylibUi.YYToolbar,
            { className: (0, _classnames2.default)(this.getClassName(), viewMode), enableAffix: enableAffix },
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-left' },
                _react2.default.createElement(_yylibUi.YYButton, { type: 'ghost', icon: 'left', ref: 'ijz_toolbar_left', visible: goBackBtnVisible,
                    onClick: this.onItemButtonClick.bind(null, 'ijz_toolbar_left', undefined)
                }),
                bigTitle
            ),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-right' },
                this.renderButtons()
            )
        );
    }
});

module.exports = IjzToolBar;