'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * 固钉组件 Created by office on 2016/7/29.
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Affix = _require.Affix;
//定义META


var uiMeta = {
    name: 'affix',
    fields: [field('offsetTop', undefined, PropTypes.number, false, '距离窗口顶部达到指定偏移量后触发'), field('offsetBottom', undefined, PropTypes.number, false, '距离窗口底部达到指定偏移量后触发'), field('onChange', null, PropTypes.func, false, '固定状态改变时触发的回调函数'), field('target', null, PropTypes.func, false, '设置 Affix 需要监听其滚动事件的元素，值为一个返回对应 DOM 元素的函数，默认获取样式为 yyui-app 的节点或者window')]
};
var YYAffix = YYClass.create({
    uiMeta: uiMeta,
    //默认相对于yyui-app进行定位，否则为null(即相对window进行定位)
    _getDefaultTarget: function _getDefaultTarget() {
        var apps = document.getElementsByClassName('yyui-app');
        if (apps && apps.length) {
            return apps[0];
        } else {
            var appRoot = document.getElementById('app_root');
            if (appRoot) {
                return appRoot;
            }
        }
        return null;
    },
    render: function render() {
        var target = this.props.target ? this.props.target : this._getDefaultTarget;
        return React.createElement(
            Affix,
            _extends({}, this.props, { target: target, className: this.className() }),
            this.props.children
        );
    }
});
module.exports = YYAffix;