'use strict';

/**
 * 下拉菜单组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Dropdown = _require.Dropdown,
    Menu = _require.Menu;

require('./style/index.less');
//定义META
var uiMeta = {
    name: 'dropdown',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('trigger', 'hover', PropTypes.oneOf(['click', 'hover']), false, '触发下拉的行为'), field('overlay', '', PropTypes.instanceOf(Menu), false, '菜单'), field('getPopupContainer', null, PropTypes.func, false, '菜单渲染父节点。默认渲染到 body 上'), field('visible', undefined, PropTypes.bool, false, '菜单是否显示'), field('onVisibleChange', null, PropTypes.func, false, '菜单显示状态改变时调用，参数为 { visible }')]
};
var YYDropdown = YYClass.create({
    uiMeta: uiMeta
    /*,statics:{
        Button:Dropdown.Button
    }*/
    , render: function render() {
        var content = typeof this.props.children == 'string' ? React.createElement(
            'span',
            null,
            this.props.children
        ) : this.props.children;
        return React.createElement(
            'div',
            { className: this.className() },
            React.createElement(
                Dropdown,
                this.props,
                content
            )
        );
    }
});
module.exports = YYDropdown;