'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * 步骤条组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Steps = _require.Steps;

require('./style/index.less');
//定义META
var uiMeta = {
    name: 'steps',
    fields: [
    // field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('current', 0, PropTypes.number, false, '指定当前步骤，从 0 开始记数。在子 Step 元素中，可以通过 status 属性覆盖状态    '), field('status', 'process', PropTypes.oneOf(['wait', 'process', 'finish', 'error']), false, '指定当前步骤的状态'), field('size', 'default', PropTypes.oneOf(['default', 'small']), false, '大小'), field('direction', 'default', PropTypes.oneOf(['default', 'vertical']), false, '步骤条方向')]
};
var YYSteps = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var children = this.props.children ? this.props.children : [];
        return React.createElement(
            Steps,
            _extends({ className: this.className(), style: this.props.style }, this.props),
            children
        );
    }
});
module.exports = YYSteps;